package com.iamberry.wechat.handles.integral;



import com.iamberry.wechat.core.entity.PageBean;
import com.iamberry.wechat.core.entity.ResultMsg;
import com.iamberry.wechat.core.entity.WechatUtils;
import com.iamberry.wechat.core.entity.integral.UseIntegral;
import com.iamberry.wechat.core.entity.member.Member;
import com.iamberry.wechat.face.integral.UseIntegralService;
import com.iamberry.wechat.tools.NameUtils;
import com.iamberry.wechat.tools.ResultInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;


import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 会员积分使用 Controller
 */
@Controller
@RequestMapping("/wechat/userIntegral")
public class UseIntegralHandler {

    @Autowired
    private UseIntegralService useIntegralService;

    /**
     * 收入记录 use_type=1
     * @param req
     * @param useType
     * @param pageSize
     * @param pageNO
     * @return
     */
    @RequestMapping("/listGainIntegralInfo")
    @ResponseBody
    public ResultMsg listGainIntegralInfo(HttpServletRequest req,
                                    @RequestParam(value="useType",defaultValue= "1", required=false)Integer useType,
                                     @RequestParam(value="pageSize",defaultValue= "6", required=false)String pageSize,
                                     @RequestParam(value="pageNO",defaultValue= "1", required=false)String pageNO){
        ResultMsg rm=new ResultMsg();
        Member m= WechatUtils.getUserBySession(req);
        int gainIntegralCount=useIntegralService.getGainIntegralCount(m.getUserOpenid());
        if(gainIntegralCount<0){
            rm.setStatus(false);
            rm.setResultCode(ResultInfo.ERRORCODE);
            rm.setMessage(NameUtils.getConfig("ERRORINFO"));
            return rm;
        }
        UseIntegral useIntegral=new UseIntegral();
        useIntegral.setUserOpenId(m.getUserOpenid());
        useIntegral.setUseType(useType);
        useIntegral.getPage().setPageSize(Integer.parseInt(pageSize));
        useIntegral.getPage().setPageNumber(Integer.parseInt(pageNO));
        List<UseIntegral> listGainIntegralInfo=useIntegralService.listIntegralInfo(useIntegral);

        Map<String,Object> map=new HashMap<String, Object>();
        map.put("listGainIntegralInfo",listGainIntegralInfo);
        map.put("gainIntegralCount",gainIntegralCount);

        rm.setStatus(true);
        rm.setResultCode(ResultInfo.SUCCESSCODE);
        rm.setMessage(NameUtils.getConfig("SUCCESSINFO"));
        rm.setData(map);
        return rm;
    }

    /**
     * 全部记录 use_type=null
     * @param req
     * @param useType
     * @param pageSize
     * @param pageNO
     * @return
     */
    @RequestMapping("/listAllIntegralInfo")
    @ResponseBody
    public ResultMsg listAllIntegralInfo(HttpServletRequest req,
                                   @RequestParam(value="useType",defaultValue= "null", required=false)Integer useType,
                                   @RequestParam(value="pageSize",defaultValue= "6", required=false)String pageSize,
                                   @RequestParam(value="pageNO",defaultValue= "1", required=false)String pageNO){
        ResultMsg rm=new ResultMsg();
        Member m=WechatUtils.getUserBySession(req);
        int useIntegralCount=useIntegralService.getUseIntegralCount(m.getUserOpenid());
        int gainIntegralCount=useIntegralService.getGainIntegralCount(m.getUserOpenid());
        if(useIntegralCount<0||gainIntegralCount<0){
            rm.setStatus(false);
            rm.setResultCode(ResultInfo.ERRORCODE);
            rm.setMessage(NameUtils.getConfig("ERRORINFO"));
            return rm;
        }
        UseIntegral useIntegral=new UseIntegral();
        useIntegral.setUserOpenId(m.getUserOpenid());
        useIntegral.setUseType(useType);
        useIntegral.getPage().setPageSize(Integer.parseInt(pageSize));
        useIntegral.getPage().setPageNumber(Integer.parseInt(pageNO));
        List<UseIntegral> listAllIntegralInfo=useIntegralService.listIntegralInfo(useIntegral);

        Map<String,Object> map=new HashMap<String, Object>();
        map.put("listAllIntegralInfo",listAllIntegralInfo);
        map.put("useIntegralCount",useIntegralCount);
        map.put("gainIntegralCount",gainIntegralCount);

        rm.setStatus(true);
        rm.setResultCode(ResultInfo.SUCCESSCODE);
        rm.setMessage(NameUtils.getConfig("SUCCSSINFO"));
        rm.setData(map);
        return rm;
    }



}
